#include <stdio.h> /*required for file io definitions*/
#include <stdlib.h>
// #include <malloc.h>
#include <math.h>
#include "xgscalar.h"
#define TWOPI 		6.283185307
#define NSMAX		4
#define MAXG		300
#define MAXG1		MAXG+1
#define MAXMODE	8
#define MAXNP		500
#define MAXHIST	256

#ifndef max()
#define max(x, y)       (((x) > (y)) ? (x) : (y))
#endif

#ifndef min()
#define min(x, y)       (((x) < (y)) ? (x) : (y))
#endif

#ifndef DBL_MIN
#define DBL_MIN         1E-200
#endif

#ifndef True
#define True            1
#endif

#ifndef False
#define False           0
#endif

/***********************************/
						  
#if defined(GLOBALORIGIN)
#define GLOBAL
#else
#define GLOBAL extern
#endif

GLOBAL SCALAR **pos, **vx, **vy, **vz, **gamma_func, 
	*x_array, *eyl, *eyr, *ezl, *ezr, 
	*jym, *jzm, *jyp, *jzp, *phi, *rho, 
	*thermx, *ex, *ey, *ez, *by, *bz, 
        *ek, *ksq, *ms, *qs, *nm, *rnmc2i, 
	*tx, *tz, length, dx, dt, rho0, ke, cgshl;

GLOBAL SCALAR *bye_hst, *bze_hst, *exe_hst, *eye_hst, 
	*eze_hst, *eyle_hst, *eyre_hst, *ezle_hst,
	*ezre_hst, *vxosc, *vyosc, *vzosc, 
	**px_hst, **py_hst, **pz_hst, *t_array,
	*px, *py, *pz, exe, eye, eze, bye, bze, 
	eyle, eyre, ezle, ezre;
				 
GLOBAL FILE *InputDeck;

GLOBAL SCALAR t;

GLOBAL int 	 np[NSMAX], nsp, nc, ng, ng2, dawsacc, nkays,
				 kay[8], circular, interval, hist_hi;

GLOBAL SCALAR frand();

#undef GLOBAL


